<?php

	/**
	 * Erlaubt die Definition und Anzeige von Lieferzeiten 
	 * @author Daschmi 
	 */
	class wpsg_mod_deliverytime extends wpsg_mod_basic
	{
		
		var $lizenz = 1;
		var $id = 1610;
		var $hilfeURL = 'http://wpshopgermany.de/?p=3968';
		
		const MODE_DAYS = 1;
		const MODE_SELECT = 2;
		
		/**
		 * Costructor
		 */
		public function __construct()
		{
				
			parent::__construct();
				
			$this->name = __('Lieferzeit', 'wpsg');
			$this->group = __('Produkte', 'wpsg');
			$this->desc = __('Erlaubt die Definition und Anzeige von Lieferzeiten.', 'wpsg');
		
		} // public function __construct()
		
		public function install()
		{
			
			require_once(WPSG_PATH_WP.'/wp-admin/includes/upgrade.php');
			
			/**
			 * Produkt Tabelle erweitern
			 */ 
			$sql = "CREATE TABLE ".WPSG_TBL_PRODUCTS." (
		   		wpsg_mod_deliverytime_deliverytime VARCHAR(255) NOT NULL, 
				wpsg_mod_deliverytime_storeproduct VARCHAR (255) NOT NULL
		   	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
   	   	 
   			dbDelta($sql); 			
			
			// Vorgaben
			$this->shop->checkDefault('wpsg_mod_deliverytime_mode', self::MODE_DAYS);
			$this->shop->checkDefault('wpsg_mod_deliverytime_mode_days_default', '7');
			$this->shop->checkDefault('wpsg_mod_deliverytime_mode_select_values', __('3 Tage, 1 Woche, 3 Wochen', 'wpsg'), false, true);
			$this->shop->checkDefault('wpsg_mod_deliverytime_mode_select_default', __('1 Woche', 'wpsg'), false, true);
			$this->shop->checkDefault('wpsg_mod_deliverytime_show_product', '1');
			$this->shop->checkDefault('wpsg_mod_deliverytime_show_basket', '1');
			$this->shop->checkDefault('wpsg_mod_deliverytime_show_overview', '1');
			$this->shop->checkDefault('wpsg_mod_deliverytime_show_mail', '1');
			
		} // public function install()
		
		public function product_addedit_content(&$product_content, &$product_data)
		{
		
			if ($this->shop->get_option('wpsg_mod_deliverytime_mode') == self::MODE_SELECT)
			{
				
				$this->shop->view['wpsg_mod_deliverytime']['arSelection'] = $this->getPossibleSelection();
				
			}
			
			$this->shop->view['wpsg_mod_deliverytime']['wpsg_mod_deliverytime_deliverytime'] = $product_data['wpsg_mod_deliverytime_deliverytime'];
			$this->shop->view['wpsg_mod_deliverytime']['wpsg_mod_deliverytime_storeproduct'] = $product_data['wpsg_mod_deliverytime_storeproduct'];
				
			$product_content['general']['content'] .= $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_deliverytime/produkt_addedit_allgemein.phtml', false);
		}
		
		
		public function settings_edit()
		{
			
			$this->shop->view['wpsg_mod_deliverytime']['arSelection'] = $this->getPossibleSelection();
			
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_deliverytime/settings_edit.phtml');
			
		} // public function settings_edit()
		
		public function settings_save()
		{
			
			$this->shop->update_option('wpsg_mod_deliverytime_mode', $_REQUEST['wpsg_mod_deliverytime_mode']);
			$this->shop->update_option('wpsg_mod_deliverytime_mode_select_values', $_REQUEST['wpsg_mod_deliverytime_mode_select_values']);
			$this->shop->update_option('wpsg_mod_deliverytime_mode_select_default', $_REQUEST['wpsg_mod_deliverytime_mode_select_default']);
			$this->shop->update_option('wpsg_mod_deliverytime_mode_days_default', $_REQUEST['wpsg_mod_deliverytime_mode_days_default']);

			$this->shop->update_option('wpsg_mod_deliverytime_store', $_REQUEST['wpsg_mod_deliverytime_store']);
			$this->shop->update_option('wpsg_mod_deliverytime_storetext', $_REQUEST['wpsg_mod_deliverytime_storetext']);
			$this->shop->update_option('wpsg_page_mod_deliverytime_storelink', $_REQUEST['wpsg_page_mod_deliverytime_storelink']);
			
			$this->shop->update_option('wpsg_mod_deliverytime_show_product', $_REQUEST['wpsg_mod_deliverytime_show_product']);
			$this->shop->update_option('wpsg_mod_deliverytime_show_basket', $_REQUEST['wpsg_mod_deliverytime_show_basket']);
			$this->shop->update_option('wpsg_mod_deliverytime_show_overview', $_REQUEST['wpsg_mod_deliverytime_show_overview']);
			$this->shop->update_option('wpsg_mod_deliverytime_show_mail', $_REQUEST['wpsg_mod_deliverytime_show_mail']);
			$this->shop->update_option('wpsg_mod_deliverytime_delay', $_REQUEST['wpsg_mod_deliverytime_delay']);
			$this->shop->update_option('wpsg_mod_deliverytime_delayText', $_REQUEST['wpsg_mod_deliverytime_delayText']);
			$this->shop->update_option('wpsg_mod_deliverytime_delayTime', $_REQUEST['wpsg_mod_deliverytime_delayTime']);
			
			$this->shop->addTranslationString('wpsg_mod_deliverytime_mode_select_values', $_REQUEST['wpsg_mod_deliverytime_mode_select_values']);
			$this->shop->addTranslationString('wpsg_mod_deliverytime_mode_select_default', $_REQUEST['wpsg_mod_deliverytime_mode_select_default']);
			
		} // public function settings_save()
		 
		public function produkt_save_before(&$produkt_data)
		{
				
			$produkt_data['wpsg_mod_deliverytime_deliverytime'] = wpsg_q($_REQUEST['wpsg_mod_deliverytime']['wpsg_mod_deliverytime_deliverytime']);
			$produkt_data['wpsg_mod_deliverytime_storeproduct'] = wpsg_q($_REQUEST['wpsg_mod_deliverytime']['wpsg_mod_deliverytime_storeproduct']); 
				
		} // public function produkt_save_before(&$produkt_data)
		
		public function mail_row($index, $produkt) 
		{ 
			
			if ($this->shop->get_option('wpsg_mod_deliverytime_show_mail') != '1') return;
			
			$this->shop->view['wpsg_mod_deliverytime']['i'] = $index;
			$this->shop->view['wpsg_mod_deliverytime']['p'] = $produkt;
			$this->shop->view['wpsg_mod_deliverytime']['deliverytime'] = $this->getProductDeliveryTime($this->shop->getProduktID($produkt['id']));
			
			if ($this->shop->htmlMail === true)
			{
					
				$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_deliverytime/mail_row_html.phtml');
					
			}
			else
			{
			
				$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_deliverytime/mail_row.phtml');
					
			}
			
		} // public function mail_row($index, $produkt)
		
		public function basket_row(&$p, $i) 
		{ 
			
			if ($this->shop->get_option('wpsg_mod_deliverytime_show_basket') != '1') return;
			
			$this->shop->view['wpsg_mod_deliverytime']['i'] = $i;
			$this->shop->view['wpsg_mod_deliverytime']['p'] = $p;
			$this->shop->view['wpsg_mod_deliverytime']['deliverytime'] = $this->getProductDeliveryTime($this->shop->getProduktID($p['id']));
			
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_deliverytime/basket_row.phtml');
			
		} // public function basket_row(&$p, $i)
		
		public function overview_row(&$p, $i) 
		{ 

			if ($this->shop->get_option('wpsg_mod_deliverytime_show_overview') != '1') return;
			
			$this->shop->view['wpsg_mod_deliverytime']['i'] = $i;
			$this->shop->view['wpsg_mod_deliverytime']['p'] = $p;
			$this->shop->view['wpsg_mod_deliverytime']['deliverytime'] = $this->getProductDeliveryTime($this->shop->getProduktID($p['id']));
			
			return $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_deliverytime/overview_row.phtml');
			
		} // public function overview_row(&$p, $i)
		
		public function wpsg_mod_export_loadFields(&$arFields) 
		{ 
			
			$arFields[20]['fields']['product_deliverytime'] = __('Lieferzeit', 'wpsg');
			
		} // public function wpsg_mod_export_loadFields(&$arFields)
		
		public function wpsg_mod_export_getValue(&$return, $field_value, $o_id, $p_id, $productkey, $product_index, $profil_separator) 
		{ 
			
			if ($field_value == 'product_deliverytime')
			{
				
				$return = $this->getProductDeliveryTime($p_id);
				
			}
			
		} // public function wpsg_mod_export_getValue(&$return, $field_value, $o_id, $p_id, $productkey, $product_index, $profil_separator)
		
		/* Modul Functions */
		
		/**
		 * Zeigt einen Text an, der bei Lieferverzögerungen angezeigt wird
		 * @param $product_key
		 */
		public function displayDelayTime($product_key)
		{
			
			if ($this->shop->get_option('wpsg_mod_deliverytime_delay') != '1') return false;
			
			return wpsg_translate(__('Aufgrund von #1# kann es zu Verzögerungen von #2# Tage(n) in der Zustellung kommen.', 'wpsg'), $this->shop->get_option('wpsg_mod_deliverytime_delayText'), $this->shop->get_option('wpsg_mod_deliverytime_delayTime'));
			
		} // public function displayDelayTime($product_key)
		
		/**
		 * Zeigt die Lieferzeit formatiert an.
		 * Bsp: Lieferzeit: 4 Tag(e)
		 */
		public function displayDeliveryTime($product_key, $valueOnly = false) 
		{
			
			$oProduct = wpsg_product::getInstance($this->shop->getProduktID($product_key));
			
			$strValue = "";
			
			if ($this->shop->get_option('wpsg_mod_deliverytime_mode') == wpsg_mod_deliverytime::MODE_DAYS) 
			{
			
				if (wpsg_isSizedInt($oProduct->wpsg_mod_deliverytime_deliverytime)) 
				{ 
					
					/* Lieferzeit > 0 im Produkte */
					$strValue = wpsg_translate(__('#1# Tag(e)', 'wpsg'), $oProduct->wpsg_mod_deliverytime_deliverytime);
					
				}
				else if (wpsg_isSizedInt($this->shop->get_option('wpsg_mod_deliverytime_mode_days_default')) && $oProduct->wpsg_mod_deliverytime_deliverytime != '0') 
				{
					
					/* Lieferzeit > 0 Global */
					$strValue = wpsg_translate(__('#1# Tag(e)', 'wpsg'), $this->shop->get_option('wpsg_mod_deliverytime_mode_days_default'));
					
				}
				else
				{
				
					$strValue = __('Das Produkt ist sofort lieferbar (Lieferzeit: 0 Tage)', 'wpsg');
				
				}
				
			}
			else 
			{
				
				$arPossibleDelivery = wpsg_trim(explode(',', $this->shop->get_option('wpsg_mod_deliverytime_mode_select_values')));
			
				if (wpsg_isSizedString($oProduct->wpsg_mod_deliverytime_deliverytime) && in_array($oProduct->wpsg_mod_deliverytime_deliverytime, $arPossibleDelivery)) 
				{
										
					$strValue = __($oProduct->wpsg_mod_deliverytime_deliverytime, 'wpsg');
					
				}
				else
				{
					
					if (array_key_exists($this->shop->get_option('wpsg_mod_deliverytime_mode_select_default'), $arPossibleDelivery))
					{
					
						$strValue = __(@$arPossibleDelivery[$this->shop->get_option('wpsg_mod_deliverytime_mode_select_default')], 'wpsg');
						
					}
					else
					{
						
						$strValue = __('Ungültige Lieferzeitkonfiguration', 'wpsg');
						
					}
					 
				}
							
			}
			
			if ($valueOnly === true) return $strValue;
			else return wpsg_translate(__('Lieferzeit: #1#', 'wpsg'), $strValue);
					
		} // public function displayDeliveryTime($product_key)
 		
		/**
		 * Gibt true zurück, wenn das Produkt ein Offline Produkt ist, und die Option "Offline Produkte verwenden" aktiviert ist
		 * @param string $product_key
		 */
		public function isStoreProduct($product_key)
		{
			
			// Wenn die Option für "Offline Produkte" nicht aktiviert ist, so kann es auch kein Offline Produkt sein
			if ($this->shop->get_option('wpsg_mod_deliverytime_store') != '1') return false;
			
			$oProduct = wpsg_product::getInstance($this->shop->getProduktID($product_key));
						
			if ($oProduct->wpsg_mod_deliverytime_storeproduct > 0) return true;
			else return false;
			
		} // public function isStoreProduct($product_key)
		
		/**
		 * Gibt die Lieferzeit eines Produktes anhand seiner ID zurück
		 * @param unknown $product_id
		 */
		public function getProductDeliveryTime($product_id)
		{
			
			$product_data = $this->shop->cache->loadProduct($product_id);
			
			if ($this->shop->get_option('wpsg_mod_deliverytime_mode') == self::MODE_DAYS)
			{
			
				if (!wpsg_isSizedString($product_data['wpsg_mod_deliverytime_deliverytime']))
				{
				
					return $this->shop->get_option('wpsg_mod_deliverytime_mode_days_default').__(' Tag(e)', 'wpsg');	
				
				}
				else
				{
					
					return $product_data['wpsg_mod_deliverytime_deliverytime'].__(' Tag(e)', 'wpsg');
					
				}
				
			}
			else if ($this->shop->get_option('wpsg_mod_deliverytime_mode') == self::MODE_SELECT)
			{
			
				$arPossibleDeliveryTimes = $this->getPossibleSelection();
				
				if (!in_array($product_data['wpsg_mod_deliverytime_deliverytime'], $arPossibleDeliveryTimes))
				{
					
					return __($this->shop->get_option('wpsg_mod_deliverytime_mode_select_default'), 'wpsg');
										
				}
				else
				{
					
					return __($product_data['wpsg_mod_deliverytime_deliverytime'], 'wpsg');
					
				}
				
			}
			
		} // public function getProductDeliveryTime($product_id)
		
		/**
		 * Gibt die möglichen Lieferzeiten als Array zurück, ist nur Sinnvoll wenn 
		 * MODE_SELECT aktiv ist.
		 */
		public function getPossibleSelection()
		{
			
			return wpsg_trim(explode(',', $this->shop->get_option('wpsg_mod_deliverytime_mode_select_values')));
			
		} // public function getPossibleSelection()
						
	} // class wpsg_mod_deliverytime extends wpsg_mod_basic

?>